--- old/usr/src/lib/libshare/common/scfutil.c	2013-09-10 06:31:59.539151228 +0100
+++ new/usr/src/lib/libshare/common/scfutil.c	2013-09-10 06:31:59.549188091 +0100
@@ -24,6 +24,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright (c) 2013 RackTop Systems.
+ */
+
 /* helper functions for using libscf with sharemgr */
 
 #include <libscf.h>
@@ -43,8 +47,8 @@
 
 ssize_t scf_max_name_len;
 extern struct sa_proto_plugin *sap_proto_list;
-extern sa_handle_impl_t get_handle_for_root(xmlNodePtr);
-static void set_transaction_tstamp(sa_handle_impl_t);
+extern sa_handle_t get_handle_for_root(xmlNodePtr);
+static void set_transaction_tstamp(sa_handle_t);
 /*
  * The SMF facility uses some properties that must exist. We want to
  * skip over these when processing protocol options.
@@ -97,7 +101,7 @@
  */
 
 scfutilhandle_t *
-sa_scf_init(sa_handle_impl_t ihandle)
+sa_scf_init(sa_handle_t ihandle)
 {
 	scfutilhandle_t *handle;
 
@@ -141,7 +145,7 @@
 	handle->scf_state = SCH_STATE_INIT;
 	if (sa_get_instance(handle, "default") != SA_OK) {
 		sa_group_t defgrp;
-		defgrp = sa_create_group((sa_handle_t)ihandle, "default", NULL);
+		defgrp = sa_create_group(ihandle, "default", NULL);
 		/* Only NFS enabled for "default" group. */
 		if (defgrp != NULL)
 			(void) sa_create_optionset(defgrp, "nfs");
@@ -1349,7 +1353,7 @@
  */
 
 int
-sa_end_transaction(scfutilhandle_t *handle, sa_handle_impl_t sahandle)
+sa_end_transaction(scfutilhandle_t *handle, sa_handle_t sahandle)
 {
 	int ret = SA_OK;
 
@@ -1392,7 +1396,7 @@
  * last transaction. This lets us detect changes from other processes.
  */
 static void
-set_transaction_tstamp(sa_handle_impl_t sahandle)
+set_transaction_tstamp(sa_handle_t sahandle)
 {
 	char tstring[32];
 	struct timeval tv;
@@ -1776,9 +1780,8 @@
 			}
 			/* Make sure we cleanup the transaction */
 			if (ret == SA_OK) {
-				sa_handle_impl_t sahandle;
-				sahandle = (sa_handle_impl_t)
-				    sa_find_group_handle(group);
+				sa_handle_t sahandle;
+				sahandle = sa_find_group_handle(group);
 				if (sahandle != NULL)
 					ret = sa_end_transaction(handle,
 					    sahandle);
